package SlidingCar "The model examines different wheel types interacting with different ground types."
  package Components "Package containing components used in the SlidingCar example"
    extends Modelica.Icons.Package;

    model PowerTrainSpeed "Powertrain using a Modelica.Mechanics.Rotational.Sources.Speed component to set the angle of the front wheels"
      PlanarMechanics.Parts.Body body(enableGravity = false, m = 100, I = 1) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {-60, 90}), visible = true));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation1(r = {0, 2}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {0, -2})));
      PlanarMechanics.Parts.Body body1(I = 0.1, enableGravity = false, m = 300, each r.fixed = true, each v.fixed = true, phi(fixed = true), w(fixed = true)) annotation(Placement(transformation(extent = {{12, -30}, {32, -10}})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation2(r = {0.75, 0}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, origin = {-20, -40})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation3(r = {-0.75, 0}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 180, origin = {20, -40})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation4(r = {0.75, 0}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, origin = {-20, 20})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation5(r = {-0.75, 0}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 180, origin = {20, 20})));
      PlanarMechanics.Parts.Body body2(enableGravity = false, m = 100, I = 1) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {50, 90}), visible = true));
      Modelica.Blocks.Sources.Pulse pulse(period = 10, offset = 0, startTime = 7, width = 30, amplitude = 0.2, nperiod = 1) annotation(Placement(transformation(extent = {{20, 70}, {0, 90}}, origin = {0, 0}, rotation = 0), visible = true));
      PlanarMechanics.Parts.FixedTranslation leftTrail(r = {0., -0.05}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {-60, 64}), visible = true));
      PlanarMechanics.Parts.FixedTranslation rightTrail(r = {0., -0.05}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {50, 64}), visible = true));
      PlanarMechanics.Joints.Revolute revolute2(useFlange = true, phi(fixed = true, start = 0), w(fixed = true)) annotation(Placement(transformation(extent = {{10, -10}, {-10, 10}}, rotation = -270, origin = {-60, 40}), visible = true));
      PlanarMechanics.Joints.Revolute revolute(useFlange = true) annotation(Placement(transformation(extent = {{-10, 10}, {10, -10}}, rotation = 270, origin = {50, 40}), visible = true));
      PlanarMechanics.Interfaces.Frame_b frame_b annotation(Placement(visible = true, transformation(origin = {-90, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      PlanarMechanics.Interfaces.Frame_a frame_a annotation(Placement(visible = true, transformation(origin = {-60, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      PlanarMechanics.Interfaces.Frame_a frame_a1 annotation(Placement(visible = true, transformation(origin = {60, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -47.908}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      PlanarMechanics.Interfaces.Frame_b frame_b1 annotation(Placement(visible = true, transformation(origin = {80, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 51.848}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Mechanics.Rotational.Sources.Speed speed annotation(Placement(visible = true, transformation(origin = {-20, 80}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    equation
      connect(fixedTranslation2.frame_b, fixedTranslation1.frame_a) annotation(Line(points = {{-10, -40}, {0, -40}, {0, -12}, {0, -12}}, color = {95, 95, 95}, thickness = 0.5));
      connect(fixedTranslation3.frame_b, fixedTranslation1.frame_a) annotation(Line(points = {{10, -40}, {0, -40}, {0, -12}}, color = {95, 95, 95}, thickness = 0.5));
      connect(body1.frame_a, fixedTranslation1.frame_a) annotation(Line(points = {{12, -20}, {0, -20}, {0, -12}}, color = {95, 95, 95}, thickness = 0.5));
      connect(fixedTranslation1.frame_b, fixedTranslation4.frame_b) annotation(Line(points = {{0, 8}, {0, 8}, {0, 20}, {-10, 20}}, color = {95, 95, 95}, thickness = 0.5));
      connect(fixedTranslation1.frame_b, fixedTranslation5.frame_b) annotation(Line(points = {{0, 8}, {0, 8}, {0, 20}, {10, 20}}, color = {95, 95, 95}, thickness = 0.5));
      connect(body.frame_a, leftTrail.frame_b) annotation(Line(points = {{0, 3}, {0, -3}}, color = {95, 95, 95}, thickness = 0.5, visible = true, origin = {-60, 77}));
      connect(body2.frame_a, rightTrail.frame_b) annotation(Line(points = {{0, 3}, {0, -3}}, color = {95, 95, 95}, thickness = 0.5, visible = true, origin = {50, 77}));
      connect(leftTrail.frame_a, revolute2.frame_a) annotation(Line(points = {{0, 2}, {0, -2}}, color = {95, 95, 95}, thickness = 0.5, visible = true, origin = {-60, 52}));
      connect(revolute2.frame_b, fixedTranslation4.frame_a) annotation(Line(points = {{-10, 6.667}, {-10, -3.333}, {20, -3.333}}, color = {95, 95, 95}, thickness = 0.5, visible = true, origin = {-50, 23.333}));
      connect(revolute.flange_a, revolute2.flange_a) annotation(Line(points = {{65, 0}, {-45, 0}}, visible = true, origin = {-5, 40}));
      connect(revolute.frame_a, rightTrail.frame_a) annotation(Line(points = {{0, -2}, {0, 2}}, color = {95, 95, 95}, thickness = 0.5, visible = true, origin = {50, 52}));
      connect(revolute.frame_b, fixedTranslation5.frame_a) annotation(Line(points = {{6.667, 6.667}, {6.667, -3.333}, {-13.333, -3.333}}, color = {95, 95, 95}, thickness = 0.5, visible = true, origin = {43.333, 23.333}));
      connect(fixedTranslation2.frame_a, frame_a) annotation(Line(visible = true, points = {{15, 0}, {-15, 0}}, color = {95, 95, 95}, thickness = 0.5, origin = {-45, -40}));
      connect(frame_a1, fixedTranslation3.frame_a) annotation(Line(visible = true, points = {{15, 0}, {-15, 0}}, color = {95, 95, 95}, thickness = 0.5, origin = {45, -40}));
      connect(leftTrail.frame_b, frame_b) annotation(Line(visible = true, points = {{12.8, 0.4}, {12.8, 3.4}, {-4.2, 3.4}, {-4.2, -3.6}, {-17.2, -3.6}}, color = {95, 95, 95}, thickness = 0.5, origin = {-72.8, 73.6}));
      connect(frame_b1, rightTrail.frame_b) annotation(Line(visible = true, points = {{17.2, -3.6}, {4.2, -3.6}, {4.2, 3.4}, {-12.8, 3.4}, {-12.8, 0.4}}, color = {95, 95, 95}, thickness = 0.5, origin = {62.8, 73.6}));
      connect(pulse.y, speed.w_ref) annotation(Line(visible = true, origin = {-4.5, 80}, points = {{3.5, 0}, {-3.5, 0}}, color = {1, 37, 163}));
      connect(speed.flange, revolute2.flange_a) annotation(Line(visible = true, origin = {-43.5, 60}, points = {{13.5, 20}, {-3.5, 20}, {-3.5, -20}, {-6.5, -20}}, color = {64, 64, 64}));
      annotation(Documentation(info = "<html>

    <p>
This is a model of a very simple power train, containing everything except the wheels and engine. A speed component is used to set the angle of the front wheels, enabling the car to turn. In this case, a pulse will be fed to the speed component over 3 seconds (between seconds 7 and 10), and the new direction of the front wheels will then be kept throughout the simulation. The base of this model is taken from the <a href=\"modelica://PlanarMechanics.VehicleComponents.Examples.TwoTrackWithDifferentialGear\">TwoTrackWithDifferentialGear</a> example from the <a href=\"modelica://PlanarMechanics\">Planar Mechanics Library</a>.
</p></html>"), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Rectangle(visible = true, fillColor = {88, 88, 88}, fillPattern = FillPattern.Solid, extent = {{-5.961, -45.021}, {5.961, 45.021}}), Text(visible = true, origin = {0, 125.215}, extent = {{-129.266, -25.215}, {129.266, 25.215}}, textString = "%name"), Rectangle(visible = true, origin = {0.08, -49.177}, fillColor = {88, 88, 88}, fillPattern = FillPattern.Solid, extent = {{-60.08, -9.177}, {60.08, 9.177}}), Rectangle(visible = true, origin = {-0.08, 50.823}, fillColor = {88, 88, 88}, fillPattern = FillPattern.Solid, extent = {{-60.08, -9.177}, {60.08, 9.177}}), Ellipse(visible = true, origin = {0, -50}, fillColor = {88, 88, 88}, fillPattern = FillPattern.Solid, extent = {{-15, -15}, {15, 15}})}), Diagram(coordinateSystem(extent = {{-148.5, -60}, {148.5, 105}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})));
    end PowerTrainSpeed;

    model PowerTrainTorque "Powertrain using a Modelica.Mechanics.Rotational.Sources.Torque component to set the angle of the front wheels"
      PlanarMechanics.Parts.Body body(g = {0, 0}, m = 100, I = 1) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {-40, 90})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation1(r = {0, 2}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {0, -2})));
      PlanarMechanics.Parts.Body body1(I = 0.1, g = {0, 0}, m = 300, r(fixed = true), v(fixed = true), phi(fixed = true), w(fixed = true)) annotation(Placement(transformation(extent = {{12, -30}, {32, -10}})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation2(r = {0.75, 0}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, origin = {-20, -40})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation3(r = {-0.75, 0}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 180, origin = {20, -40})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation4(r = {0.75, 0}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, origin = {-20, 20})));
      PlanarMechanics.Parts.FixedTranslation fixedTranslation5(r = {-0.75, 0}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 180, origin = {20, 20})));
      PlanarMechanics.Parts.Body body2(g = {0, 0}, m = 100, I = 1) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {40, 90})));
      Modelica.Mechanics.Rotational.Sources.Torque torque annotation(Placement(transformation(extent = {{10, 70}, {30, 90}}, origin = {-90, -40}, rotation = 0), visible = true));
      PlanarMechanics.Parts.FixedTranslation leftTrail(r = {0., -0.05}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {-40, 64})));
      PlanarMechanics.Parts.FixedTranslation rightTrail(r = {0., -0.05}) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 90, origin = {40, 64})));
      PlanarMechanics.Joints.Revolute revolute2(useFlange = true, phi(fixed = true, start = 0), w(fixed = true)) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 270, origin = {-40, 40}), visible = true));
      PlanarMechanics.Joints.Revolute revolute(useFlange = true) annotation(Placement(transformation(extent = {{-10, 10}, {10, -10}}, rotation = 270, origin = {40, 40})));
      PlanarMechanics.Interfaces.Frame_b frame_b annotation(Placement(visible = true, transformation(origin = {-70, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      PlanarMechanics.Interfaces.Frame_a frame_a annotation(Placement(visible = true, transformation(origin = {-60, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      PlanarMechanics.Interfaces.Frame_a frame_a1 annotation(Placement(visible = true, transformation(origin = {60, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -47.908}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      PlanarMechanics.Interfaces.Frame_b frame_b1 annotation(Placement(visible = true, transformation(origin = {70, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 51.848}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Step step(startTime = 7, height = 10) annotation(Placement(visible = true, transformation(origin = {-110, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(fixedTranslation2.frame_b, fixedTranslation1.frame_a) annotation(Line(points = {{-10, -40}, {0, -40}, {0, -12}, {0, -12}}, color = {95, 95, 95}, thickness = 0.5));
      connect(fixedTranslation3.frame_b, fixedTranslation1.frame_a) annotation(Line(points = {{10, -40}, {0, -40}, {0, -12}}, color = {95, 95, 95}, thickness = 0.5));
      connect(body1.frame_a, fixedTranslation1.frame_a) annotation(Line(points = {{12, -20}, {0, -20}, {0, -12}}, color = {95, 95, 95}, thickness = 0.5));
      connect(fixedTranslation1.frame_b, fixedTranslation4.frame_b) annotation(Line(points = {{0, 8}, {0, 8}, {0, 20}, {-10, 20}}, color = {95, 95, 95}, thickness = 0.5));
      connect(fixedTranslation1.frame_b, fixedTranslation5.frame_b) annotation(Line(points = {{0, 8}, {0, 8}, {0, 20}, {10, 20}}, color = {95, 95, 95}, thickness = 0.5));
      connect(body.frame_a, leftTrail.frame_b) annotation(Line(points = {{-40, 80}, {-40, 74}}, color = {95, 95, 95}, thickness = 0.5));
      connect(body2.frame_a, rightTrail.frame_b) annotation(Line(points = {{40, 80}, {40, 74}}, color = {95, 95, 95}, thickness = 0.5));
      connect(leftTrail.frame_a, revolute2.frame_a) annotation(Line(points = {{0, 2}, {0, -2}}, color = {95, 95, 95}, thickness = 0.5, visible = true, origin = {-40, 52}));
      connect(revolute2.frame_b, fixedTranslation4.frame_a) annotation(Line(points = {{-3.333, 6.667}, {-3.333, -3.333}, {6.667, -3.333}}, color = {95, 95, 95}, thickness = 0.5, visible = true, origin = {-36.667, 23.333}));
      connect(torque.flange, revolute2.flange_a) annotation(Line(points = {{-5, 0}, {5, 0}}, visible = true, origin = {-55, 40}));
      connect(revolute.flange_a, revolute2.flange_a) annotation(Line(points = {{50, 40}, {-50, 40}}, visible = true));
      connect(revolute.frame_a, rightTrail.frame_a) annotation(Line(points = {{40, 50}, {40, 54}}, color = {95, 95, 95}, thickness = 0.5));
      connect(revolute.frame_b, fixedTranslation5.frame_a) annotation(Line(points = {{40, 30}, {40, 20}, {30, 20}}, color = {95, 95, 95}, thickness = 0.5));
      connect(fixedTranslation2.frame_a, frame_a) annotation(Line(visible = true, points = {{15, 0}, {-15, 0}}, color = {95, 95, 95}, thickness = 0.5, origin = {-45, -40}));
      connect(frame_a1, fixedTranslation3.frame_a) annotation(Line(visible = true, points = {{15, 0}, {-15, 0}}, color = {95, 95, 95}, thickness = 0.5, origin = {45, -40}));
      connect(leftTrail.frame_b, frame_b) annotation(Line(visible = true, points = {{12.8, 0.4}, {12.8, 3.4}, {-4.2, 3.4}, {-4.2, -3.6}, {-17.2, -3.6}}, color = {95, 95, 95}, thickness = 0.5, origin = {-52.8, 73.6}));
      connect(frame_b1, rightTrail.frame_b) annotation(Line(visible = true, points = {{17.2, -3.6}, {4.2, -3.6}, {4.2, 3.4}, {-12.8, 3.4}, {-12.8, 0.4}}, color = {95, 95, 95}, thickness = 0.5, origin = {52.8, 73.6}));
      connect(step.y, torque.tau) annotation(Line(visible = true, origin = {-90.5, 40}, points = {{-8.5, 0}, {8.5, 0}}, color = {1, 37, 163}));
      annotation(Documentation(info = "<html>

    <p>
This is a model of a very simple power train, containing everything except the wheels and engine. A torque component is used to set the angle of the front wheels, enabling the car to turn. In this case, a step signal will be fed to the torque component, starting from second 7. This turning torque on the front wheels will be applied to the end of the simulation. The base of this model is taken from the <a href=\"modelica://PlanarMechanics.VehicleComponents.Examples.TwoTrackWithDifferentialGear\">TwoTrackWithDifferentialGear</a> example from the <a href=\"modelica://PlanarMechanics\">Planar Mechanics Library</a>.
</p></html>"), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Rectangle(visible = true, fillColor = {88, 88, 88}, fillPattern = FillPattern.Solid, extent = {{-5.961, -45.021}, {5.961, 45.021}}), Text(visible = true, origin = {0, 125.215}, extent = {{-129.266, -25.215}, {129.266, 25.215}}, textString = "%name"), Rectangle(visible = true, origin = {0.08, -49.177}, fillColor = {88, 88, 88}, fillPattern = FillPattern.Solid, extent = {{-60.08, -9.177}, {60.08, 9.177}}), Rectangle(visible = true, origin = {-0.08, 50.823}, fillColor = {88, 88, 88}, fillPattern = FillPattern.Solid, extent = {{-60.08, -9.177}, {60.08, 9.177}}), Ellipse(visible = true, origin = {0, -50}, fillColor = {88, 88, 88}, fillPattern = FillPattern.Solid, extent = {{-15, -15}, {15, 15}})}), Diagram(coordinateSystem(extent = {{-148.5, -60}, {148.5, 105}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})));
    end PowerTrainTorque;

    package Wheels "Package containing different wheel models"
      import SI = Modelica.Units.SI;
      import MB = Modelica.Mechanics.MultiBody;

      model SummerTireOnAsphalt "Model of a car tire on asphalt"
        PlanarMechanics.Interfaces.Frame_a frame_a annotation(Placement(transformation(extent = {{-48, 0}, {-28, 20}}, origin = {-62, -10}, rotation = 0), iconTransformation(extent = {{-68, -20}, {-28, 20}}, origin = {-52, -0}, rotation = 0), visible = true));
        outer PlanarMechanics.PlanarWorld planarWorld "planar world model";
        parameter StateSelect stateSelect = StateSelect.default "Priority to use acceleration as states" annotation(HideResult = true, Dialog(tab = "Advanced"));
        parameter Modelica.Units.SI.Length radius = 0.25 "radius of the wheel";
        parameter Modelica.Units.SI.Length r[2] = {0, 1} "driving direction of the wheel at angle phi = 0";
        parameter Modelica.Units.SI.Force N = 1000 "normal force";
        parameter Modelica.Units.SI.Velocity vAdhesion = 0.15 "adhesion velocity";
        parameter Modelica.Units.SI.Velocity vSlide = 0.35 "sliding velocity";
        parameter Real mu_A = 0.9 "friction coefficient at adhesion";
        parameter Real mu_S = 0.7 "friction coefficient at sliding";
        final parameter Modelica.Units.SI.Length l = sqrt(r * r);
        final parameter Real e[2] = r / l "normalized direction";
        Real e0[2] "normalized direction w.r.t inertial system";
        Real R[2, 2] "Rotation Matrix";
        Modelica.Units.SI.Angle phi_roll(stateSelect = stateSelect, start = 0) "roll angle of the wheel" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.AngularVelocity w_roll(final stateSelect = stateSelect, start = 0) "roll velocity of wheel" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v[2] "velocity";
        Modelica.Units.SI.Velocity v_lat(start = 0) "driving in lateral direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_long(start = 0) "velocity in longitudinal direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip_long(start = 0) "slip velocity in longitudinal direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip_lat(start = 0) "slip velocity in lateral direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip "slip velocity";
        Modelica.Units.SI.Force f "longitudinal force";
        Modelica.Units.SI.Force f_lat "longitudinal force";
        Modelica.Units.SI.Force f_long "longitudinal force";
        parameter Boolean animate = true "= true, if animation shall be enabled" annotation(Dialog(group = "Animation"));
        parameter Boolean SimVis = false "perform animation with SimVis" annotation(Dialog(group = "Animation"));
        parameter Modelica.Units.SI.Length zPosition = planarWorld.defaultZPosition "z position of the body" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        parameter Modelica.Units.SI.Length diameter = 0.1 "diameter of the rims" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        parameter Modelica.Units.SI.Length width = diameter * 0.6 "width of the wheel" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        input Modelica.Mechanics.MultiBody.Types.SpecularCoefficient specularCoefficient = planarWorld.defaultSpecularCoefficient "Reflection of ambient light (= 0: light is completely absorbed)" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        MB.Visualizers.Advanced.Shape cylinder(shapeType = "cylinder", color = {63, 63, 63}, specularCoefficient = specularCoefficient, length = width, width = radius * 2, height = radius * 2, lengthDirection = {-e0[2], e0[1], 0}, widthDirection = {0, 0, 1}, r_shape = -0.03 * {-e0[2], e0[1], 0}, r = {frame_a.x, frame_a.y, zPosition}, R = MB.Frames.nullRotation()) if planarWorld.enableAnimation and animate;
        MB.Visualizers.Advanced.Shape rim1(shapeType = "cylinder", color = {195, 195, 195}, specularCoefficient = specularCoefficient, length = radius * 2, width = diameter, height = diameter, lengthDirection = {0, 0, 1}, widthDirection = {1, 0, 0}, r_shape = {0, 0, -radius}, r = {frame_a.x, frame_a.y, zPosition}, R = MB.Frames.planarRotation({-e0[2], e0[1], 0}, flange_a.phi, 0)) if planarWorld.enableAnimation and animate;
        MB.Visualizers.Advanced.Shape rim2(shapeType = "cylinder", color = {195, 195, 195}, specularCoefficient = specularCoefficient, length = radius * 2, width = diameter, height = diameter, lengthDirection = {0, 0, 1}, widthDirection = {1, 0, 0}, r_shape = {0, 0, -radius}, r = {frame_a.x, frame_a.y, zPosition}, R = MB.Frames.planarRotation({-e0[2], e0[1], 0}, flange_a.phi + Modelica.Constants.pi / 2, 0)) if planarWorld.enableAnimation and animate;
        Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation(Placement(transformation(extent = {{90, -10}, {110, 10}}, origin = {0, 0}, rotation = 0), iconTransformation(extent = {{90, -10}, {110, 10}}, origin = {0, 0}, rotation = 0), visible = true));
      equation
        R = {{cos(frame_a.phi), -sin(frame_a.phi)}, {sin(frame_a.phi), cos(frame_a.phi)}};
        e0 = R * e;
        v = der({frame_a.x, frame_a.y});
        phi_roll = flange_a.phi;
        w_roll = der(phi_roll);
        v_long = v * e0;
        v_lat = -v[1] * e0[2] + v[2] * e0[1];
        v_slip_lat = v_lat - 0;
        v_slip_long = v_long - radius * w_roll;
        v_slip = sqrt(v_slip_long ^ 2 + v_slip_lat ^ 2) + 0.0001;
        -f_long * radius = flange_a.tau;
        frame_a.t = 0;
        f = N * noEvent(PlanarMechanics.Utilities.Functions.limitByStriple(vAdhesion, vSlide, mu_A, mu_S, v_slip));
        f_long = f * v_slip_long / v_slip;
        f_lat = f * v_slip_lat / v_slip;
        f_long = {frame_a.fx, frame_a.fy} * e0;
        f_lat = {frame_a.fy, -frame_a.fx} * e0;
        annotation(Icon(graphics = {Text(visible = true, extent = {{-100, -140}, {100, -100}}, textString = "%name"), Bitmap(visible = true, rotation = -360, fileName = "modelica://SlidingCar.Components.Wheels.SummerTireOnAsphalt/DocumentationFiles/TireOnAsphalt2.jpg", imageSource = "", extent = {{-100, -100}, {100, 100}})}, coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10})), Documentation(info = "<html>

    <p>
This model of a summer tire on asphalt is based on the <a href=\"modelica://PlanarMechanics.VehicleComponents.Wheels.DryFrictionWheelJoint\">DryFrictionWheelJoint</a> model from the <a href=\"modelica://PlanarMechanics\">Planar Mechanics Library</a>. The friction coefficients for adhesion and sliding have been adjusted to fit the condition of a summer tire on asphalt. The friction coefficient at adhesion is set to 0.9, and the friction coefficient at sliding is set to 0.7.
</p></html>"));
      end SummerTireOnAsphalt;

      model SummerTireOnGravel "Model of a car tire on gravel"
        PlanarMechanics.Interfaces.Frame_a frame_a annotation(Placement(transformation(extent = {{-48, 0}, {-28, 20}}, origin = {-62, -10}, rotation = 0), iconTransformation(extent = {{-68, -20}, {-28, 20}}, origin = {-52, -0}, rotation = 0), visible = true));
        Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation(Placement(transformation(extent = {{90, -8}, {110, 12}}, origin = {0, 0}, rotation = 0), iconTransformation(extent = {{90, -10}, {110, 10}}, origin = {0, 0}, rotation = 0), visible = true));
        outer PlanarMechanics.PlanarWorld planarWorld "planar world model";
        parameter StateSelect stateSelect = StateSelect.default "Priority to use acceleration as states" annotation(HideResult = true, Dialog(tab = "Advanced"));
        parameter Modelica.Units.SI.Length radius = 0.25 "radius of the wheel";
        parameter Modelica.Units.SI.Length r[2] = {0, 1} "driving direction of the wheel at angle phi = 0";
        parameter Modelica.Units.SI.Force N = 1000 "normal force";
        parameter Modelica.Units.SI.Velocity vAdhesion = 0.1 "adhesion velocity";
        parameter Modelica.Units.SI.Velocity vSlide = 0.3 "sliding velocity";
        parameter Real mu_A = 0.7 "friction coefficient at adhesion";
        parameter Real mu_S = 0.5 "friction coefficient at sliding";
        final parameter Modelica.Units.SI.Length l = sqrt(r * r);
        final parameter Real e[2] = r / l "normalized direction";
        Real e0[2] "normalized direction w.r.t inertial system";
        Real R[2, 2] "Rotation Matrix";
        Modelica.Units.SI.Angle phi_roll(stateSelect = stateSelect, start = 0) "roll angle of the wheel" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.AngularVelocity w_roll(final stateSelect = stateSelect, start = 0) "roll velocity of wheel" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v[2] "velocity";
        Modelica.Units.SI.Velocity v_lat(start = 0) "driving in lateral direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_long(start = 0) "velocity in longitudinal direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip_long(start = 0) "slip velocity in longitudinal direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip_lat(start = 0) "slip velocity in lateral direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip "slip velocity";
        Modelica.Units.SI.Force f "longitudinal force";
        Modelica.Units.SI.Force f_lat "longitudinal force";
        Modelica.Units.SI.Force f_long "longitudinal force";
        parameter Boolean animate = true "= true, if animation shall be enabled" annotation(Dialog(group = "Animation"));
        parameter Boolean SimVis = false "perform animation with SimVis" annotation(Dialog(group = "Animation"));
        parameter Modelica.Units.SI.Length zPosition = planarWorld.defaultZPosition "z position of the body" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        parameter Modelica.Units.SI.Length diameter = 0.1 "diameter of the rims" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        parameter Modelica.Units.SI.Length width = diameter * 0.6 "width of the wheel" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        input Modelica.Mechanics.MultiBody.Types.SpecularCoefficient specularCoefficient = planarWorld.defaultSpecularCoefficient "Reflection of ambient light (= 0: light is completely absorbed)" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        Modelica.Mechanics.MultiBody.Visualizers.Advanced.Shape cylinder(shapeType = "cylinder", color = {63, 63, 63}, specularCoefficient = specularCoefficient, length = width, width = radius * 2, height = radius * 2, lengthDirection = {-e0[2], e0[1], 0}, widthDirection = {0, 0, 1}, r_shape = -0.03 * {-e0[2], e0[1], 0}, r = {frame_a.x, frame_a.y, zPosition}, R = Modelica.Mechanics.MultiBody.Frames.nullRotation()) if planarWorld.enableAnimation and animate;
        Modelica.Mechanics.MultiBody.Visualizers.Advanced.Shape rim1(shapeType = "cylinder", color = {195, 195, 195}, specularCoefficient = specularCoefficient, length = radius * 2, width = diameter, height = diameter, lengthDirection = {0, 0, 1}, widthDirection = {1, 0, 0}, r_shape = {0, 0, -radius}, r = {frame_a.x, frame_a.y, zPosition}, R = Modelica.Mechanics.MultiBody.Frames.planarRotation({-e0[2], e0[1], 0}, flange_a.phi, 0)) if planarWorld.enableAnimation and animate;
        Modelica.Mechanics.MultiBody.Visualizers.Advanced.Shape rim2(shapeType = "cylinder", color = {195, 195, 195}, specularCoefficient = specularCoefficient, length = radius * 2, width = diameter, height = diameter, lengthDirection = {0, 0, 1}, widthDirection = {1, 0, 0}, r_shape = {0, 0, -radius}, r = {frame_a.x, frame_a.y, zPosition}, R = Modelica.Mechanics.MultiBody.Frames.planarRotation({-e0[2], e0[1], 0}, flange_a.phi + Modelica.Constants.pi / 2, 0)) if planarWorld.enableAnimation and animate;
      equation
        R = {{cos(frame_a.phi), -sin(frame_a.phi)}, {sin(frame_a.phi), cos(frame_a.phi)}};
        e0 = R * e;
        v = der({frame_a.x, frame_a.y});
        phi_roll = flange_a.phi;
        w_roll = der(phi_roll);
        v_long = v * e0;
        v_lat = -v[1] * e0[2] + v[2] * e0[1];
        v_slip_lat = v_lat - 0;
        v_slip_long = v_long - radius * w_roll;
        v_slip = sqrt(v_slip_long ^ 2 + v_slip_lat ^ 2) + 0.0001;
        -f_long * radius = flange_a.tau;
        frame_a.t = 0;
        f = N * noEvent(PlanarMechanics.Utilities.Functions.limitByStriple(vAdhesion, vSlide, mu_A, mu_S, v_slip));
        f_long = f * v_slip_long / v_slip;
        f_lat = f * v_slip_lat / v_slip;
        f_long = {frame_a.fx, frame_a.fy} * e0;
        f_lat = {frame_a.fy, -frame_a.fx} * e0;
        annotation(Icon(graphics = {Text(visible = true, extent = {{-100, -140}, {100, -100}}, textString = "%name"), Bitmap(visible = true, fileName = "modelica://SlidingCar.Components.Wheels.SummerTireOnGravel/DocumentationFiles/TireOnGravel.jpg", imageSource = "", extent = {{-100, -100}, {100, 100}})}, coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10})), Documentation(info = "<html>

    <p>
This model of a summer tire on gravel is based on the <a href=\"modelica://PlanarMechanics.VehicleComponents.Wheels.DryFrictionWheelJoint\">DryFrictionWheelJoint</a> model from the <a href=\"modelica://PlanarMechanics\">Planar Mechanics Library</a>. The friction coefficients for adhesion and sliding have been adjusted to fit the condition of a summer tire on gravel. The friction coefficient at adhesion is set to 0.7, and the friction coefficient at sliding is set to 0.5.
</p></html>"));
      end SummerTireOnGravel;

      model SummerTireOnIce "Model of a car tire on ice"
        PlanarMechanics.Interfaces.Frame_a frame_a annotation(Placement(transformation(extent = {{-48, 0}, {-28, 20}}, origin = {-62, -10}, rotation = 0), iconTransformation(extent = {{-68, -20}, {-28, 20}}, origin = {-52, 0}, rotation = 0), visible = true));
        Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation(Placement(transformation(extent = {{90, -8}, {110, 12}}), iconTransformation(extent = {{90, -10}, {110, 10}})));
        outer PlanarMechanics.PlanarWorld planarWorld "planar world model";
        parameter StateSelect stateSelect = StateSelect.default "Priority to use acceleration as states" annotation(HideResult = true, Dialog(tab = "Advanced"));
        parameter Modelica.Units.SI.Length radius = 0.25 "radius of the wheel";
        parameter Modelica.Units.SI.Length r[2] = {0, 1} "driving direction of the wheel at angle phi = 0";
        parameter Modelica.Units.SI.Force N = 1000 "normal force";
        parameter Modelica.Units.SI.Velocity vAdhesion = 0.1 "adhesion velocity";
        parameter Modelica.Units.SI.Velocity vSlide = 0.3 "sliding velocity";
        parameter Real mu_A = 0.1 "friction coefficient at adhesion";
        parameter Real mu_S = 0.05 "friction coefficient at sliding";
        final parameter Modelica.Units.SI.Length l = sqrt(r * r);
        final parameter Real e[2] = r / l "normalized direction";
        Real e0[2] "normalized direction w.r.t inertial system";
        Real R[2, 2] "Rotation Matrix";
        Modelica.Units.SI.Angle phi_roll(stateSelect = stateSelect, start = 0) "roll angle of the wheel" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.AngularVelocity w_roll(final stateSelect = stateSelect, start = 0) "roll velocity of wheel" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v[2] "velocity";
        Modelica.Units.SI.Velocity v_lat(start = 0) "driving in lateral direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_long(start = 0) "velocity in longitudinal direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip_long(start = 0) "slip velocity in longitudinal direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip_lat(start = 0) "slip velocity in lateral direction" annotation(Dialog(group = "Initialization", showStartAttribute = true));
        Modelica.Units.SI.Velocity v_slip "slip velocity";
        Modelica.Units.SI.Force f "longitudinal force";
        Modelica.Units.SI.Force f_lat "longitudinal force";
        Modelica.Units.SI.Force f_long "longitudinal force";
        parameter Boolean animate = true "= true, if animation shall be enabled" annotation(Dialog(group = "Animation"));
        parameter Boolean SimVis = false "perform animation with SimVis" annotation(Dialog(group = "Animation"));
        parameter Modelica.Units.SI.Length zPosition = planarWorld.defaultZPosition "z position of the body" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        parameter Modelica.Units.SI.Length diameter = 0.1 "diameter of the rims" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        parameter Modelica.Units.SI.Length width = diameter * 0.6 "width of the wheel" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        input Modelica.Mechanics.MultiBody.Types.SpecularCoefficient specularCoefficient = planarWorld.defaultSpecularCoefficient "Reflection of ambient light (= 0: light is completely absorbed)" annotation(Dialog(tab = "Animation", group = "if animation = true", enable = animate));
        Modelica.Mechanics.MultiBody.Visualizers.Advanced.Shape cylinder(shapeType = "cylinder", color = {63, 63, 63}, specularCoefficient = specularCoefficient, length = width, width = radius * 2, height = radius * 2, lengthDirection = {-e0[2], e0[1], 0}, widthDirection = {0, 0, 1}, r_shape = -0.03 * {-e0[2], e0[1], 0}, r = {frame_a.x, frame_a.y, zPosition}, R = Modelica.Mechanics.MultiBody.Frames.nullRotation()) if planarWorld.enableAnimation and animate;
        Modelica.Mechanics.MultiBody.Visualizers.Advanced.Shape rim1(shapeType = "cylinder", color = {195, 195, 195}, specularCoefficient = specularCoefficient, length = radius * 2, width = diameter, height = diameter, lengthDirection = {0, 0, 1}, widthDirection = {1, 0, 0}, r_shape = {0, 0, -radius}, r = {frame_a.x, frame_a.y, zPosition}, R = Modelica.Mechanics.MultiBody.Frames.planarRotation({-e0[2], e0[1], 0}, flange_a.phi, 0)) if planarWorld.enableAnimation and animate;
        Modelica.Mechanics.MultiBody.Visualizers.Advanced.Shape rim2(shapeType = "cylinder", color = {195, 195, 195}, specularCoefficient = specularCoefficient, length = radius * 2, width = diameter, height = diameter, lengthDirection = {0, 0, 1}, widthDirection = {1, 0, 0}, r_shape = {0, 0, -radius}, r = {frame_a.x, frame_a.y, zPosition}, R = Modelica.Mechanics.MultiBody.Frames.planarRotation({-e0[2], e0[1], 0}, flange_a.phi + Modelica.Constants.pi / 2, 0)) if planarWorld.enableAnimation and animate;
      equation
        R = {{cos(frame_a.phi), -sin(frame_a.phi)}, {sin(frame_a.phi), cos(frame_a.phi)}};
        e0 = R * e;
        v = der({frame_a.x, frame_a.y});
        phi_roll = flange_a.phi;
        w_roll = der(phi_roll);
        v_long = v * e0;
        v_lat = -v[1] * e0[2] + v[2] * e0[1];
        v_slip_lat = v_lat - 0;
        v_slip_long = v_long - radius * w_roll;
        v_slip = sqrt(v_slip_long ^ 2 + v_slip_lat ^ 2) + 0.0001;
        -f_long * radius = flange_a.tau;
        frame_a.t = 0;
        f = N * noEvent(PlanarMechanics.Utilities.Functions.limitByStriple(vAdhesion, vSlide, mu_A, mu_S, v_slip));
        f_long = f * v_slip_long / v_slip;
        f_lat = f * v_slip_lat / v_slip;
        f_long = {frame_a.fx, frame_a.fy} * e0;
        f_lat = {frame_a.fy, -frame_a.fx} * e0;
        annotation(Icon(graphics = {Text(visible = true, extent = {{-100, -140}, {100, -100}}, textString = "%name"), Bitmap(visible = true, fileName = "modelica://SlidingCar.Components.Wheels.SummerTireOnIce/DocumentationFiles/TireOnIce.jpg", imageSource = "", extent = {{-100, -100}, {100, 100}})}, coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10})), Documentation(info = "<html>

    <p>
This model of a summer tire on ice is based on the <a href=\"modelica://PlanarMechanics.VehicleComponents.Wheels.DryFrictionWheelJoint\">DryFrictionWheelJoint</a> model from the <a href=\"modelica://PlanarMechanics\">Planar Mechanics Library</a>. The friction coefficients for adhesion and sliding have been adjusted to fit the condition of a summer tire on ice. The friction coefficient at adhesion is set to 0.1, and the friction coefficient at sliding is set to 0.05.
</p></html>"));
      end SummerTireOnIce;
      annotation(Documentation, Icon(coordinateSystem(preserveAspectRatio = false, extent = {{-100, -100}, {100, 100}}), graphics = {Rectangle(extent = {{-80, 100}, {100, -80}}, fillColor = {215, 230, 240}, fillPattern = FillPattern.Solid), Rectangle(extent = {{-100, 80}, {80, -100}}, fillColor = {240, 240, 240}, fillPattern = FillPattern.Solid), Ellipse(extent = {{-80, 62}, {60, -78}}, fillColor = {215, 215, 215}, fillPattern = FillPattern.Sphere), Ellipse(extent = {{-60, 40}, {40, -58}}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, pattern = LinePattern.None), Ellipse(extent = {{-20, 2}, {0, -18}}, lineColor = {0, 0, 255}, fillPattern = FillPattern.Solid)}));
    end Wheels;

    function TripleS_Func "Models a point-symmetric Triple S-Function"
      input Real x_max;
      input Real x_sat;
      input Real y_max;
      input Real y_sat;
      input Real x;
      output Real y;
    algorithm
      if x > x_max then
        y := S_Func(x_max, x_sat, y_max, y_sat, x);
      elseif x < -x_max then
        y := S_Func(-x_max, -x_sat, -y_max, -y_sat, x);
      else
        y := S_Func(-x_max, x_max, -y_max, y_max, x);
      end if;
      annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Text(visible = true, origin = {0, -5}, textColor = {255, 255, 255}, extent = {{-90, -80}, {90, 80}}, textString = "f")}), smoothOrder = 1);
    end TripleS_Func;
    annotation(Documentation);
  end Components;

  model Car "Model of a car with replaceable wheels and powertrain"
    extends Modelica.Icons.Example;
    inner PlanarMechanics.PlanarWorld planarWorld(defaultWidthFraction = 10, animateGravity = false) annotation(Placement(transformation(extent = {{-80, 0}, {-60, 20}}, origin = {-20, -80}, rotation = 0), visible = true));
    replaceable model Wheel = Components.Wheels.SummerTireOnAsphalt "Model of the wheels used in the car" annotation(choices(choice(redeclare model Wheel = SlidingCar.Components.Wheels.SummerTireOnAsphalt "Summer tire on asphalt"), choice(redeclare model Wheel = SlidingCar.Components.Wheels.SummerTireOnGravel "Summer tire on gravel"), choice(redeclare model Wheel = SlidingCar.Components.Wheels.SummerTireOnIce "Summer tire on ice")));
    Wheel WheelJoint1(phi_roll(fixed = false)) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 0, origin = {-60, 40}), visible = true));
    Wheel WheelJoint2(phi_roll.fixed = false) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 0, origin = {-60, -40}), visible = true));
    Wheel WheelJoint3 annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, origin = {60, -40}, rotation = 0), visible = true));
    Wheel WheelJoint4 annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, origin = {60, 40}, rotation = 0), visible = true));
    replaceable model PowerTrain = SlidingCar.Components.PowerTrainSpeed "Model of the powertrain used in the car" annotation(choices(choice(redeclare model PowerTrain = SlidingCar.Components.PowerTrainTorque "Power train with torque steering"), choice(redeclare model PowerTrain = SlidingCar.Components.PowerTrainSpeed "Power train with speed steering")), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, origin = {-70, 50}, fillColor = {66, 0, 0}, fillPattern = FillPattern.Solid, extent = {{-10, -20}, {10, 20}}), Rectangle(visible = true, origin = {70, 51.677}, fillColor = {66, 0, 0}, fillPattern = FillPattern.Solid, extent = {{-10, -20}, {10, 20}}), Rectangle(visible = true, origin = {70, -50}, fillColor = {66, 0, 0}, fillPattern = FillPattern.Solid, extent = {{-10, -20}, {10, 20}}), Rectangle(visible = true, origin = {-70, -50}, fillColor = {66, 0, 0}, fillPattern = FillPattern.Solid, extent = {{-10, -20}, {10, 20}}), Rectangle(visible = true, origin = {-0.142, 2.978}, lineColor = {255, 0, 0}, fillColor = {255, 255, 255}, lineThickness = 1, extent = {{-61.906, -82.978}, {61.906, 82.978}})}));
    Modelica.Mechanics.Rotational.Sources.ConstantTorque constantTorque(tau_constant = 40) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, origin = {-50, -80}, rotation = 0), visible = true));
    PlanarMechanics.VehicleComponents.DifferentialGear differentialGear annotation(Placement(transformation(extent = {{-10, -72}, {10, -52}}, origin = {0, 2}, rotation = 0), visible = true));
    PowerTrain powerTrain(revolute2.phi.fixed = false, revolute2.w.fixed = false, revolute.phi.fixed = false, revolute.w.fixed = false) annotation(Placement(visible = true, transformation(origin = {0, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.Inertia inertia4(phi(fixed = true, start = 0), w(fixed = true, start = 0), J = 1) annotation(Placement(transformation(extent = {{-10, 10}, {10, -10}}, rotation = 180, origin = {90, 40}), visible = true));
    Modelica.Mechanics.Rotational.Components.Inertia inertia3(J = 1, phi(fixed = true, start = 0), w(fixed = true, start = 0)) annotation(Placement(transformation(extent = {{-10, -10}, {10, 10}}, rotation = 180, origin = {90, -40}), visible = true));
    Modelica.Mechanics.Rotational.Components.Inertia inertia2(phi(fixed = true, start = 0), w(fixed = true, start = 0), J = 1) annotation(Placement(transformation(extent = {{-10, 10}, {10, -10}}, origin = {-30, -40}, rotation = -180), visible = true));
    Modelica.Mechanics.Rotational.Components.Inertia inertia1(phi(fixed = true, start = 0), w(fixed = true, start = 0), J = 1) annotation(Placement(transformation(extent = {{-10, 10}, {10, -10}}, origin = {-20, 40}, rotation = -180), visible = true));
  equation
    connect(differentialGear.flange_right, WheelJoint3.flange_a) annotation(Line(points = {{10, -60}, {78, -60}, {78, -40}, {70, -40}}, visible = true));
    connect(constantTorque.flange, differentialGear.flange_b) annotation(Line(points = {{-26.667, -3.333}, {13.333, -3.333}, {13.333, 6.667}}, visible = true, origin = {-13.333, -76.667}));
    connect(WheelJoint1.frame_a, powerTrain.frame_b) annotation(Line(visible = true, points = {{-6.5, 17.5}, {-16.5, 17.5}, {-16.5, -17.5}, {53.5, -17.5}}, color = {95, 95, 95}, origin = {-63.5, 22.5}));
    connect(WheelJoint3.frame_a, powerTrain.frame_a1) annotation(Line(visible = true, points = {{20.206, -17.605}, {-9.794, -17.605}, {-9.794, 17.605}, {-19.794, 17.604}}, color = {95, 95, 95}, origin = {29.794, -22.395}));
    connect(WheelJoint4.frame_a, powerTrain.frame_b1) annotation(Line(visible = true, points = {{21.506, 17.408}, {-8.494, 17.408}, {-8.494, -17.408}, {-18.494, -17.407}}, color = {95, 95, 95}, origin = {28.494, 22.592}));
    connect(inertia4.flange_b, WheelJoint4.flange_a) annotation(Line(points = {{5, 0}, {-5, 0}}, visible = true, origin = {75, 40}));
    connect(inertia3.flange_b, WheelJoint3.flange_a) annotation(Line(points = {{5, 0}, {-5, 0}}, visible = true, origin = {75, -40}));
    connect(inertia1.flange_b, WheelJoint1.flange_a) annotation(Line(points = {{10, 0}, {-10, 0}}, visible = true, origin = {-40, 40}));
    connect(WheelJoint2.flange_a, inertia2.flange_b) annotation(Line(points = {{-5, 0}, {5, 0}}, visible = true, origin = {-45, -40}));
    connect(differentialGear.flange_left, WheelJoint2.flange_a) annotation(Line(visible = true, origin = {-35, -51}, points = {{25, -9}, {-5, -9}, {-5, 11}, {-15, 11}}, color = {64, 64, 64}));
    connect(WheelJoint2.frame_a, powerTrain.frame_a) annotation(Line(visible = true, origin = {-60, -22.5}, points = {{-10, -17.5}, {-20, -17.5}, {-20, 17.5}, {50, 17.5}}, color = {95, 95, 95}));
    annotation(preferredView = "info", experiment(StartTime = 0.0, StopTime = 15, NumberOfIntervals = 2000, __Wolfram_Algorithm = "dassl", Tolerance = 1e-6, __Wolfram_MaxStepSize = 0, __Wolfram_EventHysteresisEpsilon = 1e-10, __Wolfram_AccurateEventDetection = true, __Wolfram_NonlinearSolverTolerance = 1e-12, __Wolfram_MaxInternalStepCount = 0, __Wolfram_CheckMinMax = false, __Wolfram_StopAtSteadyState = false, __Wolfram_SynchronizeWithRealTime = false), __Wolfram(PlotSet(plots = {Plot(name = "Parametric position plot of the wheels", preferred = true, subPlots = {SubPlot(curves = {Curve(x = WheelJoint1.rim1.r[1], y = WheelJoint1.rim1.r[2], legend = "Front left wheel"), Curve(x = WheelJoint2.rim1.r[1], y = WheelJoint2.rim1.r[2], legend = "Rear left wheel"), Curve(x = WheelJoint3.rim1.r[1], y = WheelJoint3.rim1.r[2], legend = "Rear right wheel"), Curve(x = WheelJoint4.rim1.r[1], y = WheelJoint4.rim1.r[2], legend = "Rear front wheel")})}), Plot(name = "Front and back wheel forces", subPlots = {SubPlot(curves = {Curve(x = time, y = WheelJoint1.f, legend = "Front left wheel"), Curve(x = time, y = WheelJoint4.f, legend = "Front rightwheel")}), SubPlot(curves = {Curve(x = time, y = WheelJoint2.f, legend = "Back left wheel"), Curve(x = time, y = WheelJoint3.f, legend = "Back right wheel")})})}), Animation(cameras = {Camera(name = "Default", center = {2.858717203140259, 7.036619186401367, 0}, distance = 33.46065521240234, rotation = {0, 0, 0, 1})}, windows = {Window(name = "Default", camera = "Default", trace = {powerTrain.fixedTranslation1.cylinder})})), Diagram(coordinateSystem(extent = {{-120, -100}, {120, 60}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10})), Documentation(info = "<html>
<div style=\"background-color: #f4fbff; padding: 1rem; border: 2px solid #d9e5f3\">
<h2>Library Dependency</h2>
    <p class=\"\">
		This model requires the <a href=\"https://www.wolfram.com/system-modeler/libraries/planar-mechanics/\">PlanarMechanics</a> library.
	</p>
	<ul>
		<li style=\"background: url('modelica://EducationExamples/Resources/PlanarMechanics.png') no-repeat left top; background-size: 32px 32px; padding-left: 40px;\">The free PlanarMechanics library was created especially for modeling multibody systems with two-dimensional mechanical components. Compared to the MultiBody library, currently available in the Modelica Standard Library, it is simpler to use and it is more optimized to planar modeling. Planar models of mechanical systems are useful in many different applications, for example, in contact problems that are more easily modeled in 2D than in 3D.</li>

	</ul>

</div>

<h4>Model</h4>

    <p>
This model shows the concept of configurable modeling. The wheels are defined as replaceable models and can easily be changed in the car model.
</p>

    <p>
This model is based on the <a href=\"modelica://PlanarMechanics.VehicleComponents.Examples.TwoTrackWithDifferentialGear\">TwoTrackWithDifferentialGear</a> example from the <a href=\"modelica://PlanarMechanics\">Planar Mechanics Library</a>. The library can be downloaded <a href=\"https://www.wolfram.com/system-modeler/libraries/planar-mechanics/\">here</a>. Four wheels interact with the ground through a friction model. Depending on the type of wheel and ground, different friction coefficients are used. To switch between different setups, use the drop-down menu in the <span>General</span> tab.
</p>
<p style=\"text-align: center;\"><img src=\"modelica://SlidingCar/DocumentationFiles/DiagramWithDropdown.png\" style=\"width:585px\"  alt=\"\" /></p>
    <h4>Simulation</h4>
    <p>
To simulate the model, click the Simulate button:<img src=\"modelica://SlidingCar/DocumentationFiles/play.svg\" style=\"width:20px\" alt=\"simulate\"/></p>
<h4>Plot the Results</h4>
    <p>
The simulation is set to run for 15 seconds. A constant torque is applied to the back wheels during the simulation. After 7 seconds, the front wheel will turn to the right over 3 seconds and then keep that front wheel angle for the rest of the simulation. See the position of the wheels of the car (as plotted below) or the forces on the wheels in the Model plots. The top plot shows the motion on asphalt and the bottom plot shows the motion on ice.
</p>

<p style=\"text-align: center;\"><img src=\"modelica://SlidingCar/DocumentationFiles/AsphaltVsIceParametricPlot.png\" style=\"width:480px\" alt=\"\" /></p>
<p style=\"text-align: center;\"><img src=\"modelica://SlidingCar/DocumentationFiles/IceParametricPlot.png\" style=\"width:480px\" alt=\"\" /></p>
</p><h4>Automatic 3D Animation</h4>
    <p>
PlanarMechanics and Multibody systems have visualizers to show what a real-world system would look like.
</p>
<p style=\"text-align: center;\"><img src=\"modelica://SlidingCar/DocumentationFiles/AnimScrShot.png\" style=\"width:300px\" alt=\"\" /></p>

<p>
To show a 3D animation of the model, click the Animate button:<img src=\"modelica://SlidingCar/DocumentationFiles/animate.svg\" style=\"width:20px\" alt=\"\"/>
</p><p>
It is also possible to add traces to the wheels to see the path they have taken over time in the animation. To do this, right-click the background in the animation and choose <span>Trace Path</span>, and then choose the components to trace. One option is to trace the different cylinders 2&ndash;5 (powerTrain.fixedTranslation2.cylinder) as shown in the following image:
</p><p style=\"text-align: center;\">
<img src=\"modelica://SlidingCar/DocumentationFiles/AnimScrShotTraces.png\"style=\"width:500px\" alt=\"AnimScrShotTraces\"/>
</p><h3>Changing the Wheels</h3>
    <p>
By using the replaceable concept, we can redeclare the Wheel model and effectively change all four wheels of the car model with a drop-down menu.
</p>
</html>"));
  end Car;
  annotation(Documentation(info = "<div style=\"background-color: #f4fbff; padding: 1rem; border: 2px solid #d9e5f3\">
<h2>Library Dependency</h2>
    <p class=\"\">
		This model requires the <a href=\"https://www.wolfram.com/system-modeler/libraries/planar-mechanics/\">PlanarMechanics</a> library.
	</p>
	<ul>
		<li style=\"background: url('modelica://EducationExamples/Resources/PlanarMechanics.png') no-repeat left top; background-size: 32px 32px; padding-left: 40px; \">The free PlanarMechanics library was created especially for modeling multibody systems with two-dimensional mechanical components. Compared to the MultiBody library, currently available in the Modelica Standard Library, it is simpler to use and it is more optimized to planar modeling. Planar models of mechanical systems are useful in many different applications, for example, in contact problems that are more easily modeled in 2D than in 3D.</li>

	</ul>

</div>"), preferredView = "info", uses(Modelica(version = "4.0.0"), PlanarMechanics(version = "1.6.0")), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {111, 0, 0}, fillColor = {255, 0, 0}, fillPattern = FillPattern.HorizontalCylinder, lineThickness = 4, extent = {{-90, -90}, {90, 90}}, radius = 25), Text(visible = true, origin = {12, 20.833}, textColor = {255, 255, 255}, extent = {{-102, -70.833}, {78, 29.167}}, textString = "Ex", fontName = "Arial")}), __Wolfram(openClass = SlidingCar.Car));
end SlidingCar;
